"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = keyReducer;

var _useKeyCaptureUtils = require("./useKeyCaptureUtils");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function keyReducer(state, action) {
  switch (action.type) {
    case _useKeyCaptureUtils.useKeyActionTypes.ESCAPE_KEY:
      {
        return _objectSpread({}, _useKeyCaptureUtils.useKeyInitialState, {
          isEscape: true
        });
      }

    case _useKeyCaptureUtils.useKeyActionTypes.ENTER_KEY:
      {
        return _objectSpread({}, _useKeyCaptureUtils.useKeyInitialState, {
          isEnter: true
        });
      }

    case _useKeyCaptureUtils.useKeyActionTypes.CAPS_ALPHABET:
      {
        return _objectSpread({}, _useKeyCaptureUtils.useKeyInitialState, {
          isCaps: true
        });
      }

    case _useKeyCaptureUtils.useKeyActionTypes.SMALL_ALPHABET:
      {
        return _objectSpread({}, _useKeyCaptureUtils.useKeyInitialState, {
          isSmall: true
        });
      }

    case _useKeyCaptureUtils.useKeyActionTypes.NUMBER:
      {
        return _objectSpread({}, _useKeyCaptureUtils.useKeyInitialState, {
          isNumber: true
        });
      }

    case _useKeyCaptureUtils.useKeyActionTypes.SPACE:
      {
        return _objectSpread({}, _useKeyCaptureUtils.useKeyInitialState, {
          isSpace: true
        });
      }

    case _useKeyCaptureUtils.useKeyActionTypes.ARROWS:
      {
        return _objectSpread({}, _useKeyCaptureUtils.useKeyInitialState, {
          isArrows: true
        }, action.payload);
      }

    default:
      return _objectSpread({}, _useKeyCaptureUtils.useKeyInitialState);
  }
}